//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * 3×3行列テストヘッダ
 * @author Junpee
 */

#ifndef MATRIX33_TEST_H_
#define MATRIX33_TEST_H_

#include <LampUnit/TestCase.h>

namespace Lamp{ class Matrix33; }

//------------------------------------------------------------------------------
/**
 * 3×3行列テスト
 */
class Matrix33Test : public TestCase{
public:
	/**
	 * コンストラクタ
	 * @param name テストの名前
	 */
	explicit Matrix33Test(String name);

	/**
	 * テストを実行する
	 */
	virtual void runTest(){}

	/**
	 * テストスィートの取得
	 * @return テストスィート
	 */
	static Test* suite();

	// コンストラクタテスト
	virtual void testConstructor();

	// 定数テスト
	virtual void testFixedNumber();

	// 値の設定テスト
	virtual void testSetValue();

	// スケールテスト
	virtual void testScale();

	// 回転テスト
	virtual void testRotation();

	// 四元数テスト
	virtual void testQuaternion();

	// 三軸回転テスト
	virtual void testThreeAxisRotation();

	// 乗算テスト
	virtual void testMul();

	// 行列演算テスト
	virtual void testMatrixOperation();

	// 論理演算テスト
	virtual void testLogicalOperation();

	// 文字列テスト
	virtual void testToString();

private:
	// Direct3D行列との比較
	bool d3dEquals(D3DXMATRIX& d3d, Matrix33& mtx);

	// Direct3D行列との比較
	bool d3dEpsilonEquals(D3DXMATRIX& d3d, Matrix33& mtx, float epsilon);

};

//------------------------------------------------------------------------------
#endif // End of MATRIX33_TEST_H_
//------------------------------------------------------------------------------
